/*
  CPP_CONTEST=2014
  CPP_PROBLEM=G
  CPP_LANG=C+OPENMP+MPI
  CPP_PROCESSES_PER_NODE=mercurio 1
*/

/* RECORD
Juan Francisco Rodríguez Herrera 
student of the University of Almería, Spain
In the IV Spanish Parallel Programming Contest
time 25789 msec
speed-up 1.87
*/ 

/*Only sequential optimizations were introduced,
removing some allocations-deallocations.
*/

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <omp.h>
 
void writesolution(int N,int *s)
{
  int i;

  for(i=0;i<N;i++)
    printf(" %d ",s[i]);
  printf("\n");
}

int critery(int N,int R,int level,int resources)
{
  return (level<N-1 && resources<=R);
}

inline int calculateattended(int L,int *p,int level,int *s, int *pos)
{
	int attended=0;
	int i,j;
	memset(pos, 0, sizeof(int)*(L+1));

	for(i=0;i<=level;i++)
	{
		if (s[i])
			for(j=0;j<=s[i];j++)
			{
				//pos[p[i]-j]=1;
				//pos[p[i]+j]=1;
				*(pos+(*(p+i)-j)) = 1;
				*(pos+(*(p+i)+j)) = 1;
			}
	}
	for(i=1;i<=L;i++)
		attended+=pos[i];

	return attended;
}

int generate(int L,int *p,int level,int *resources,int *s, int *pos)
{
  s[level]++;
  if(s[level])
    (*resources)++;
  return(calculateattended(L,p,level,s,pos));
}

int morebrothers(int R,int *r,int level,int resources,int *s)
{
  return (s[level]<r[level] && resources<R);
}

int solution(int N,int R,int level,int resources)
{
  return (level==N-1 && resources<=R);
}

int sec(int L,int N,int R,int *p,int *r)
{
  int *sol=(int *) malloc(sizeof(int)*N);
  int *pos=(int *) calloc(sizeof(int),L+1);

  int VOA=-1;
  int i,level=0;
  int resources=0;
  int attended=0;
  int seguir;

  sol[0]=0;
  for(i=1;i<N;i++)
    sol[i]=-1;
#ifdef DEBUG
  printf("partial solution at level %d, with %d positions attended: \n",level,attended);
  writesolution(N,sol);
  printf("\n");
  scanf("%d\n",&seguir);
#endif
  do
  {
    if(solution(N,R,level,resources))
    {
      if(attended>VOA)
      {
        VOA=attended;
#ifdef SOLUCION
  printf("after find solution with value %d\n",VOA);
  writesolution(N,sol);
  printf("\n");
#endif
      }
#ifdef DEBUG
  printf("after find solution with value %d\n",VOA);
  writesolution(N,sol);
  printf("\n");
  scanf("%d\n",&seguir);
#endif
    }
    if(critery(N,R,level,resources))
    {
      level++;
      attended=generate(L,p,level,&resources,sol, pos);
#ifdef DEBUG
  printf("after generate at level %d, with resources %d and attended %d : \n",level,resources,attended);
  writesolution(N,sol);
  printf("\n");
  scanf("%d\n",&seguir);
#endif
    }
    else
    {
      while(level!=-1 && !morebrothers(R,r,level,resources,sol))
      {
        resources-=sol[level];
        sol[level]=-1;
        level--;
#ifdef DEBUG
  printf("after retrodece one level %d, with resources %d : \n",level,resources);
  writesolution(N,sol);
  printf("\n");
  scanf("%d\n",&seguir);
#endif
      }
      if(level!=-1)
      {
        attended=generate(L,p,level,&resources,sol, pos);
#ifdef DEBUG
  printf("after generate a brother at level %d, with resources %d and attended %d : \n",level,resources,attended);
  writesolution(N,sol);
  printf("\n");
  scanf("%d\n",&seguir);
#endif
      }
    }
  } while(level!=-1);
  free(sol);
  free(pos);
  return VOA;
}
